FROM alpine:3.7
MAINTAINER Disassembler <disassembler@dasm.cz>

RUN \
 # Install Python2 runtime
 apk --no-cache add python2

RUN \
 # Install runtime XML dependencies
 apk --no-cache add libxml2 libxslt

RUN \
 # Add edge/testing repository
 echo '@edge http://dl-cdn.alpinelinux.org/alpine/edge/testing' >>/etc/apk/repositories \
 # Install runtime dependencies
 && apk --no-cache add geos@edge nginx py-gdal@edge py2-dateutil py2-lxml py2-numpy py2-pillow py2-psycopg2 py2-requests s6 uwsgi-python

RUN \
 # Install build dependencies
 apk --no-cache add --virtual .deps build-base git freetype-dev libpng-dev py-numpy-dev py2-pip python2-dev ttf-dejavu \
 # Hackfix for python find_library('c') call
 && ln -s /lib/ld-musl-x86_64.so.1 /lib/libc.so.1 \
 # Install web2py
 && git clone --recursive https://github.com/web2py/web2py.git /srv/web2py \
 && git -C /srv/web2py checkout 7035398 \
 && git -C /srv/web2py submodule update \
 # Fix Web2py urllib import (https://github.com/web2py/pydal/commit/9d2290c)
 && sed -i 's/import traceback/import traceback\nimport urllib/' /srv/web2py/gluon/packages/dal/pydal/base.py \
 # Symlink WSGI handler
 && ln -s /srv/web2py/handlers/wsgihandler.py /srv/web2py/wsgihandler.py \
 # Install Sahana
 && git clone --depth 1 https://github.com/sahana/eden.git /srv/web2py/applications/eden \
 # Install python dependencies, exclude old or unnecessary ones
 && sed -i 's/^ansible/#ansible/' /srv/web2py/applications/eden/optional_requirements.txt \
 && sed -i 's/^boto/#boto/' /srv/web2py/applications/eden/optional_requirements.txt \
 && sed -i 's/^PIL/#PIL/' /srv/web2py/applications/eden/optional_requirements.txt \
 && sed -i 's/^PyRTF/#PyRTF/' /srv/web2py/applications/eden/optional_requirements.txt \
 && sed -i 's/^PyYAML/#PyYAML/' /srv/web2py/applications/eden/optional_requirements.txt \
 && pip install -r /srv/web2py/applications/eden/optional_requirements.txt \
 # Copy fonts with Czech glyphs
 && cp /usr/share/fonts/ttf-dejavu/DejaVuSerif-Bold.ttf /srv/web2py/applications/eden/static/fonts/DejaVuSerif-Bold.ttf \
 && cp /usr/share/fonts/ttf-dejavu/DejaVuSerif.ttf /srv/web2py/applications/eden/static/fonts/DejaVuSerif.ttf \
 # Create OS user
 && addgroup -S -g 8001 sahana \
 && adduser -S -u 8001 -h /srv/web2py -s /bin/sh -g sahana -G sahana sahana \
 && chown -R sahana:sahana /srv/web2py \
 # Cleanup
 && apk --no-cache del .deps \
 && find /srv/web2py -name '.git*' -exec rm -rf {} + \
 && rm -r /srv/web2py/applications/admin /srv/web2py/applications/examples /srv/web2py/applications/welcome \
 && rm -r /root/.cache

COPY docker/etc/ /etc/

COPY --chown=8001:8001 docker/srv/ /srv/

VOLUME ["/srv/web2py/applications/eden/models", "/srv/web2py/applications/eden/databases", "/srv/web2py/applications/eden/uploads"]
EXPOSE 8080

CMD ["s6-svscan", "/etc/services.d"]
